<?php

/*************************************************************************
 * Login As User - XenConcept (c) 2017
 * All Rights Reserved.
 **************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at Try it like it buy it :)
 *************************************************************************/

namespace XenConcept\LoginAsUser\ModeratorLog;

use XF\Entity\ModeratorLog;
use XF\ModeratorLog\AbstractHandler;
use XF\Mvc\Entity\Entity;

class LoginAsUser extends AbstractHandler
{

    protected $reason;

    public function isLoggableUser(\XF\Entity\User $actor)
    {
        return true;
    }

    public function log(Entity $content, $action, array $params, \XF\Entity\User $actor)
    {
        $log = \XF::em()->create('XF:ModeratorLog');
        $log->content_type = $this->contentType;
        $id = $content->getIdentifierValues();
        if (!$id || count($id) != 1)
        {
            throw new \InvalidArgumentException("Entity does not have an ID or does not have a simple key");
        }
        $log->content_id = intval(reset($id));

        $this->reason = isset($params['reason']) ? $params['reason'] : '';

        $this->setupLogEntityActor($log, $actor);
        $this->setupLogEntityContent($log, $content);

        $log->action = $action;
        $log->action_params = $params;
        $log->save();

        return $log;
    }

    public function getLogActionForChange(Entity $content, $field, $newValue, $oldValue)
    {
        return true;
    }

    public function setupLogEntityContent(ModeratorLog $log, Entity $content)
    {/** @var \XF\Entity\Post $content */
        $log->content_user_id = $content->user_id;
        $log->content_username = $content->username;
        $log->content_title = $this->reason ? \XF::phrase('xc_login_as_user_reason_x', ['reason' => $this->reason]) : '';
        $log->content_url = '';
        $log->discussion_content_type = 'login_as_user';
        $log->discussion_content_id = '';
    }

    public function getActionPhraseName(ModeratorLog $log)
    {
        return 'xc_login_as_user_mod_log.' . $log->action;
    }

}