<?php
/*************************************************************************
 * Login As User - XenConcept (c) 2019
 * All Rights Reserved.
 **************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at Try it like it buy it :)
 *************************************************************************/

namespace XenConcept\LoginAsUser\Option;


class Editor
{
    public static function verifyOption(&$value, \XF\Entity\Option $option)
    {
        $value['messageBody'] = '';

        if (isset($value['messageBody_html']))
        {
            $value['messageBody'] = self::convertToBbCode($value['messageBody_html']);
            unset($value['messageBody_html']);
            return true;
        }

        return true;
    }

    public static function convertToBbCode($html, $htmlMaxLength = -1)
    {
        if ($htmlMaxLength < 0)
        {
            $htmlMaxLength = 4 * \XF::options()->messageMaxLength;
            // quadruple the limit as HTML can be a lot more verbose
        }

        if ($htmlMaxLength && utf8_strlen($html) > $htmlMaxLength)
        {
            throw \XF::phrasedException('submitted_message_is_too_long_to_be_processed');
        }

        $bbCode = \XF\Html\Renderer\BbCode::renderFromHtml($html);
        return \XF::cleanString($bbCode);
    }
}