<?php
/**
 * Created by PhpStorm.
 * User: Remi
 * Date: 29/03/2019
 * Time: 23:38
 */

namespace XenConcept\LoginAsUser\Service\LoginAsUser;

use XF\Service\AbstractService;
use XF\Util\Ip;

class Log extends AbstractService
{

    /**
     * @var \XF\Entity\User
     */
    protected $fromUser;

    /**
     * @var \XF\Entity\User
     */
    protected $toUser;

    protected $reason;

    protected $action;

    public function __construct(\XF\App $app, \XF\Entity\User $toUser, \XF\Entity\User $fromUser, $reason = '', $action = 'login')
    {
        parent::__construct($app);

        $this->toUser = $toUser;
        $this->fromUser = $fromUser;
        $this->reason = $reason;
        $this->action = $action;
    }

    public function saveLog()
    {
        if ($this->action === 'login')
        {
            $this->writeLog();
        }

        $this->writeModeratorLog($this->action);
    }

    protected function writeLog()
    {
        /** @var \XenConcept\LoginAsUser\Entity\Log $log */
        $log = $this->em()->create('XenConcept\LoginAsUser:Log');

        $log->from_user_id  = $this->fromUser->user_id;
        $log->from_username = $this->fromUser->username;
        $log->to_user_id    = $this->toUser->user_id;
        $log->to_username   = $this->toUser->username;
        $log->ip_address    = Ip::convertIpStringToBinary($this->app->request()->getIp());
        $log->reason = $this->reason;

        return $log->save();
    }

    protected function writeModeratorLog($action)
    {

        if ($action === 'login')
        {
            \XF::app()->logger()->logModeratorAction('login_as_user', \XF::visitor(), 'login', [
                'connected_username' => $this->toUser->username,
                'reason' => $this->reason
            ]);
        }
        else
        {
            \XF::app()->logger()->logModeratorAction('login_as_user', $this->toUser, 'logout', [
                'logout_username' => $this->fromUser->username,
            ]);
        }
    }

}