<?php
/**
 * Created by PhpStorm.
 * User: Remi
 * Date: 29/03/2019
 * Time: 22:55
 */

namespace XenConcept\LoginAsUser;

use XF\AddOn\AbstractSetup;
use XF\AddOn\StepRunnerInstallTrait;
use XF\AddOn\StepRunnerUninstallTrait;
use XF\AddOn\StepRunnerUpgradeTrait;
use XF\Db\Schema\Create;

class Setup extends AbstractSetup
{
    use StepRunnerInstallTrait;
    use StepRunnerUpgradeTrait;
    use StepRunnerUninstallTrait;

    public function installStep1()
    {
        $sm = $this->schemaManager();

        foreach ($this->getTables() AS $tableName => $closure)
        {
            $sm->createTable($tableName, $closure);
        }
    }

    public function upgrade2000800Step1()
    {
        $this->installStep1();
    }

    public function uninstallStep1()
    {
        $sm = $this->schemaManager();

        foreach (array_keys($this->getTables()) AS $tableName)
        {
            $sm->dropTable($tableName);
        }
    }

    protected function getTables()
    {
        $tables = [];

        $tables['xf_xc_lau_logs'] = function (Create $table)
        {
            $table->checkExists(true);

            $table->addColumn('log_id', 'int')->autoIncrement();
            $table->addColumn('from_user_id', 'int')->setDefault(0);
            $table->addColumn('from_username', 'varchar', 50);
            $table->addColumn('to_user_id', 'int')->setDefault(0);
            $table->addColumn('to_username', 'varchar', 50);
            $table->addColumn('log_date', 'int')->setDefault(0);
            $table->addColumn('reason', 'varchar', 255);
            $table->addColumn('ip_address', 'varbinary', 16)->setDefault('');
        };

        return $tables;
    }
}