<?php

/*************************************************************************
 * Login As User - XenConcept (c) 2019
 * All Rights Reserved.
 **************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at Try it like it buy it :)
 *************************************************************************/

namespace XenConcept\LoginAsUser\XF\Admin\Controller;

class Log extends XFCP_Log
{

    public function actionLoginAsUser()
    {
        $logRepo = $this->getLoginAsUserLogRepo();
        $logFinder = $logRepo->findLogForList();

        $page = $this->filterPage();
        $perPage = 20;

        $logFinder->limitByPage($page, $perPage);

        $viewParams = [
            'logs' => $logFinder->fetch(),
            'total' => $logFinder->total(),

            'page' => $page,
            'perPage' => $perPage
        ];
        return $this->view('XenConcept\LoginAsUser:Log\LoginAsUser', 'xc_lau_log_list', $viewParams);
    }

    public function actionLoginAsUserDelete()
    {
        $log = $this->assertLogExists($this->filter('log_id', 'uint'));

        if ($this->isPost())
        {
            $log->delete();
            return $this->redirect($this->buildLink('logs/login-as-user'));
        }
        else
        {
            $viewParams = [
                'log' => $log
            ];
            return $this->view('XenConcept\LoginAsUser:Log\LoginAsUser', 'xc_lau_log_delete', $viewParams);
        }
    }

    public function actionLoginAsUserMassDelete()
    {
        $this->assertPostOnly();

        $deletes = $this->filter('delete', 'array-str');

        $logs = $this->em()->findByIds('XenConcept\LoginAsUser:Log', $deletes);
        foreach ($logs AS $log)
        {
            $log->delete();
        }

        return $this->redirect($this->buildLink('logs/login-as-user'));
    }

    /**
     * @param string $id
     * @param array|string|null $with
     * @param null|string $phraseKey
     * @throws
     * @return \XenConcept\LoginAsUser\Entity\Log
     */
    protected function assertLogExists($id, $with = null, $phraseKey = null)
    {
        return $this->assertRecordExists('XenConcept\LoginAsUser:Log', $id, $with, $phraseKey);
    }

    /**
     * @return \XenConcept\LoginAsUser\Repository\Log
     */
    protected function getLoginAsUserLogRepo()
    {
        return $this->repository('XenConcept\LoginAsUser:Log');
    }

}