<?php

/*************************************************************************
 * Login As User - XenConcept (c) 2019
 * All Rights Reserved.
 **************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at Try it like it buy it :)
 *************************************************************************/

namespace XenConcept\LoginAsUser\XF\ControllerPlugin;

class Login extends XFCP_Login
{

    public function loginAsUser(\XF\Entity\User $fromUser, \XF\Entity\User $toUser, $urlRevert)
    {
        $loginAsUser = [
            'from_user_id' => $fromUser->user_id,
            'to_style_id'  => $toUser->style_id,
            'url_revert'   => $urlRevert
        ];

        $overrideStyle = \XF::options()->xc_login_as_user_override_style;
        if ($overrideStyle)
        {
            $toUser->fastUpdate('style_id', $overrideStyle);
        }

        $this->session->changeUser($toUser);
        $this->session->set('login_as_user', $loginAsUser);

        return;
    }

    public function logoutAsUser(\XF\Entity\User $fromUser, \XF\Entity\User $toUser)
    {
        $loginAsUser = $this->session->get('login_as_user');

        $overrideStyle = \XF::options()->xc_login_as_user_override_style;
        if ($overrideStyle)
        {
            if ($fromUser->style_id != $loginAsUser['to_style_id'])
            {
                $fromUser->fastUpdate('style_id', $loginAsUser['to_style_id']);
            }
        }

        $this->session->changeUser($toUser);
        $this->session->set('login_as_user', null);

        return;
    }
}